-- $Id: g_queue.ads,v 1.1 2003/11/18 02:36:14 baker Exp baker $

generic
  type Item_Type is private;
  with function ">" (Left, Right: Item_Type) return boolean is <>;

package Generic_Queue is
  type Queue_Type is limited private;

procedure Clear(Queue: in out Queue_Type);
procedure Add(Item: in Item_Type; Queue: in out Queue_Type);
procedure Delete(Item: in Item_Type; Queue: in out Queue_Type);
procedure Pop(Queue: in out Queue_Type);
function Is_Empty(Queue: in Queue_Type) return boolean;
function Front_Of(Queue: in Queue_Type) return Item_Type;
function Back_Of(Queue: in Queue_Type) return Item_Type;

generic
  with procedure P(Item: in Item_Type);
procedure For_All(Queue: in Queue_Type);

private
  type Cell;
  type Link is access Cell;
  type Queue_Type is
    record
      Front: Link;
      Back : Link;
    end record;

end Generic_Queue;
